/* */
call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
call SysLoadFuncs
'@echo off'

SZ_MINOR_OF_NEW = '250'
SZ_MAJOR_OF_V3  = '8'
SZ_MAJOR_OF_V2  = '6'
SZ_MAJOR_OF_V4  = '9'

SZ_KERNEL_FILE_NAME = '\OS2KRNL'
SZ_PM_FILE_NAME = '\OS2\DLL\PMMERGE.DLL'
I_BYTES_NEEDED = 4000000

SZ_RU_TWO = 'RU'
SZ_BY_TWO = 'BY'
SZ_UA_TWO = 'UA'

SZ_WHITE = D2C(27)||'[0;1;37m'
SZ_GREY  = D2C(27)||'[0;37m'
SZ_LGREEN = D2C(27)||'[0;1;32m'
SZ_LRED = D2C(27)||'[0;1;31m'

SZ_WKW_DIR_NAME = '\WKW'
SZ_BACKUP_SUBDIR_NAME = '\BACKUP'
SZ_PMMERGE_SUBDIR_NAME = '\_PMMERGE'
SZ_VIOTBL_SUBDIR_NAME = '\_VIOTBL'
SZ_KEYBOARD_SUBDIR_NAME = '\_KEYDCP'
SZ_COUNTRY_SUBDIR_NAME = '\_COUNTRY'
SZ_DLLS_SUBDIR_NAME = '\_DLLS'
SZ_FONS_SUBDIR_NAME = '\_FONS'
SZ_UTILS_SUBDIR_NAME = '\_UTILS'

SZ_COUNTRY_FILE_NAME = '\Country.SYS'
SZ_KEYBOARD_FILE_NAME = '\CyrKbd.DCP'

SZ_CP_ALT = 'ALT'
SZ_CP_KOI8R = 'KOI8R'
SZ_CP_KOI8U = 'KOI8U'
SZ_CP_WIN = 'WIN'
SZ_CP_UKR = 'UKR'
SZ_CP_ISO = 'ISO'

/* Detect PMREXX */
If Address() = 'PMREXX' Then  Do
  'START SETUP.CMD /C /WIN'
  Exit
End

/* Determine where OS/2 instance can be found. WKW will be placed in BOOTDRIVE:\WKW */
  flagCorrectBootDrive = 0
  flagCorrectInstanceFound = 0
  flagCorrectFreeSpaceEnough = 0
do until flagCorrectFreeSpaceEnough=1
  do until flagCorrectInstanceFound=1
    do until flagCorrectBootDrive=1
      call printf 'Please specify Boot Drive of OS/2 instance, for which WKW would be installed'
      szBootDrive = substr( strip(Scanf()), 1, 1 )':'
      flagCorrectBootDrive = CheckBootDrive( szBootDrive )
      if flagCorrectBootDrive = 0 then call Printf_err '!Please specify accessible drive!'
    end
/* Check if OS/2 can be found on drive specified */
    call SysFileTree szBootDrive''SZ_KERNEL_FILE_NAME, files, 'F' 
    if files.0 = 1 then flagCorrectInstanceFound = 1
    else call Printf_err '!Please specify drive with OS/2 installed!'
  end
/* and finally check for free space - 4 megs required */
  flagCorrectFreeSpaceEnough = CheckBootDriveFreeSpace( szBootDrive )
  if flagCorrectFreeSpaceEnough = 0 then call printf 'Not enough free space on 'szBootDrive' drive - need 5 megs' 
end

/* Determine revision of system and existence of PM in it */

szMajorRevision = GetMajorRevision( szBootDrive''SZ_KERNEL_FILE_NAME )
szMinorRevision = GetMinorRevision( szBootDrive''SZ_KERNEL_FILE_NAME )

/* Determine existence of PM */
flagPMPresent = 1
call SysFileTree szBootDrive''SZ_PM_FILE_NAME, files, 'F' 
if files.0 = 0 then flagPMPresent = 0

/* Check for existence of previously installed WKW */
call SysFileTree szBootDrive''SZ_WKW_DIR_NAME, files, 'D' 
if files.0 = 1 then do /* change to = 1 later!!!!!! */
  call printf_err '!Found previously installed WKW on 'szBootDrive' drive'
  call printf_err 'WKW will not install over it'
  call printf_err 'Either uninstall it or delete - now exiting...'
  return
end


/* Configuring WKW */
  szCountry=''
  do while szCountry=''
    call printf 'Please specify your country name code'
    call printf 'Options are: BY for Belarus, RU for Russia, UA for Ukraine,'
    call printf 'blank string selects Russia'
    szCountry = CheckCountryName( strip(Scanf()) )
    if szCountry='' then call printf_err '!You specified unacceptable Country name'
  end

/* Choose substitution of Latin-1 tables (cp 850) */
  szLatSubstitution=''
  call printf 'You can substitute screen and keyboard layouts for codepage 850'
  call printf 'with layouts for one of Cyrillic codepages and switch between these codepages'
  call printf 'Or you can do this substitution later.'
  call printf 'Do you want to make such substitution now (answer + if so):'
  szSimulatedCodepage = ''
  szSimulatedKeyboard = ''
  rc = strip(Scanf())
  if substr(rc,1,1) = '+' then do
    szLatSubstitution = '+'
    call printf 'You chose to substitute layouts of codepage 850'
    call printf 'Now tell which codepage will be simulated in cp 850'
    do while szSimulatedCodepage=''
      call printf 'Options are: koi8r, koi8u (for KOI-8 ukraininan),'
      call printf 'iso (for ISO-8859-5), win (for cp 1251)'
      rc = strip(Scanf())
      if rc='' then rc = 'STD'
      szSimulatedCodepage = CheckSimulatedCodepage( rc )
      if szSimulatedCodepage = '' then call printf_err '!Not valid codepage code'
    end
    call printf 'Now tell which keyboard layout will be simulated in cp 850, blank line for the same as screen layout'
    do while szSimulatedKeyboard=''
      call printf 'Options are: koi8r, koi8u (for KOI-8 ukraininan),'
      call printf 'iso (for ISO-8859-5), win (for cp 1251)'
      rc = strip(Scanf())
      if rc='' then rc = szSimulatedCodepage
      szSimulatedKeyboard = CheckSimulatedKeyboard( rc )
      if szSimulatedKeyboard = '' then call printf_err '!Not valid codepage code'
    end
  end
  else do
    szSimulatedCodepage = 'STD'
    szSimulatedKeyboard  ='STD'
  end

  call printf 'Verifying your choices------------------------------------------'
  call printf '  installing on drive:              'SZ_LGREEN''szBootDrive
  call printf '     system revision is 'szMajorRevision'.'szMinorRevision' and PM is 'VerbForPM(flagPMPresent)
  call printf '  country code is:                  'SZ_LGREEN''szCountry
  call printf '  substituting cp850 layout with  : 'SZ_LGREEN''VerbForSimulation(szSimulatedCodepage)
  call printf '  substituting cp850 keyboard with: 'SZ_LGREEN''VerbForSimulation(szSimulatedKeyboard)
  call printf '----------------------------------------------------------------'
  call printf 'Proceed with choices? (Enter + for YES)'
  rc = strip(Scanf())
  if substr(rc,1,1) <> '+' then return


/* Making directories and backuping system files */
  call PrepareWkwDirectories szBootDrive

  call Printf 'Now backuping system files........'
  call BackupSystemFiles szBootDrive
  
/* Copying WkW files to their directories */  
  call Printf 'Now copying WKW setup files........'
  call CopyWkwFiles szBootDrive 

  if flagPMPresent = 1 then do
    call Printf 'Now copying WKW setup files for PM........'
    call CopyWkwPmFiles szBootDrive 
    /* Corrections to new copies of system files */  
    call printf 'Now modifying new copies of system files...'
    call ModifyNewSystemFiles szBootDrive szSimulatedCodepage
  end
    call Printf 'Now replacing locked system files........'
    call ReplaceLockedFiles szBootDrive

  call printf 'Now modifying CONFIG.SYS...............'
  call ModifyConfigSys szBootDrive

  call printf 'Installation finished! Shutdown and rebot to put changes into effect.'
  
  return

ReplaceLockedFiles:
  parse arg s
  
  local_s = '.'SZ_FONS_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  
  szDdpFile = s''SZ_WKW_DIR_NAME'\_fons.ddp'
  call lineout szDdpFile, ':TITLE'
  call lineout szDdpFile, 'Bitmap Cyrillic fonts (*.FON)'
  call lineout szDdpFile, ':FILES'
  szFon = '\HELV.FON '
  call lineout szDdpFile, s''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME''szFon''s'\OS2\DLL'szFon
  szFon = '\TIMES.FON '
  call lineout szDdpFile, s''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME''szFon''s'\OS2\DLL'szFon
  szFon = '\COURIER.FON '
  call lineout szDdpFile, s''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME''szFon''s'\OS2\DLL'szFon
  szFon = '\SYSMONO.FON '
  call lineout szDdpFile, s''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME''szFon''s'\OS2\DLL'szFon
  call stream szDdpFile, 'c', 'close'
  call setlocal
  s
  cd SZ_WKW_DIR_NAME''SZ_UTILS_SUBDIR_NAME
  ddinstal' 'szDdpFile
  call endlocal
  return  

ReplaceFonFile:
  return    
  
ModifyConfigSys:
  parse arg s
  call setlocal
  ''s''
  cd' 'SZ_WKW_DIR_NAME
  szConfig = s'\config.sys'
  szConfigNew = 'config_n.sys'
  local_s = ' 'szConfigNew' >nul 2>nul'
  del''local_s

  rc = stream( szConfig, 'c', 'open read' );
  rc = stream( szConfigNew, 'c', 'open write' );
  flagCountryStringWasPresent = 0
  do forever
    szT = linein(szConfig)
    szTT = translate(strip(szT))
    if substr(szTT,1,7)='COUNTRY'  then do 
      szT = 'COUNTRY=7,'szBootDrive''SZ_WKW_DIR_NAME''SZ_COUNTRY_SUBDIR_NAME''SZ_COUNTRY_FILE_NAME
      flagCountryStringWasPresent = 1
    end
    if substr(szTT,1,7)='LIBPATH'  then do
      call lineout szConfigNew, 'REM 'szT
      szT = 'LIBPATH='s''SZ_WKW_DIR_NAME''SZ_DLLS_SUBDIR_NAME';'substr(szTT,9,)
      end  
    if substr(szTT,1,8)='CODEPAGE' then do 
      call lineout szConfigNew, 'REM 'szT
      szT = 'CODEPAGE=866,850'
      end
    if substr(szTT,1,7)='DEVINFO' then do
      call lineout szConfigNew, 'REM 'szT
      szDevinfo = substr( strip(substr(szTT,8,)), 2, )
      szDevinfoDev = substr( szDevinfo, 1, 3 )
      if szDevinfoDev='KBD' then szT = 'DEVINFO=KBD,RuStd,'szBootDrive''SZ_WKW_DIR_NAME''SZ_KEYBOARD_SUBDIR_NAME''SZ_KEYBOARD_FILE_NAME
      if szDevinfoDev='SCR' then szT = 'DEVINFO=SCR,VGA,'szBootDrive''SZ_WKW_DIR_NAME''SZ_VIOTBL_SUBDIR_NAME'\'szCountry''szSimulatedCodepage'.DCP'
    end  
    call lineout szConfigNew, szT
    if lines(szConfig) = 0 then leave
  end
  if flagCountryStringWasPresent = 0 then call lineout szConfigNew, 'COUNTRY=7,'szBootDrive''SZ_WKW_DIR_NAME''SZ_COUNTRY_SUBDIR_NAME''SZ_COUNTRY_FILE_NAME
  rc = stream( szConfig, 'c', 'close' );
  rc = stream( szConfigNew, 'c', 'close' );

  local_s = ' 'szConfigNew' 'szConfig' >nul 2>nul'
  copy''local_s
  local_s = ' 'szConfigNew
  del''local_s
  call endlocal
  return


PrepareWkwDirectories:
  parse arg s
  call SysMkDir s''SZ_WKW_DIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_PMMERGE_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_VIOTBL_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_KEYBOARD_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_COUNTRY_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_DLLS_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME
  call SysMkDir s''SZ_WKW_DIR_NAME''SZ_UTILS_SUBDIR_NAME
  return
  
CopyWkwFiles:
  parse arg s
  local_s = '.'SZ_VIOTBL_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_VIOTBL_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_KEYBOARD_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_KEYBOARD_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_COUNTRY_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_COUNTRY_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_UTILS_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_UTILS_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  return

CopyWkwPmFiles:
  parse arg s
  local_s = s''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME'\PMMERGE.DLL 's''SZ_WKW_DIR_NAME''SZ_PMMERGE_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_PMMERGE_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_PMMERGE_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_DLLS_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_DLLS_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  local_s = '.'SZ_FONS_SUBDIR_NAME'\* 's''SZ_WKW_DIR_NAME''SZ_FONS_SUBDIR_NAME'  >nul 2>nul'
  copy local_s
  return

  
ModifyNewSystemFiles:  
  parse arg s
  ss = s
  call setlocal
  call Value 'PATH', ss''SZ_WKW_DIR_NAME''SZ_PMMERGE_SUBDIR_NAME, 'OS2ENVIRONMENT'
  ''szBootDrive''
  local_s = SZ_WKW_DIR_NAME''SZ_PMMERGE_SUBDIR_NAME
  cd local_s
  call printf '...deleting old 14s...'
  local_s = ' -d pmmerge.dll *.14 >nul' 
  call res''local_s
  call printf '...adding standard 14s...'
  local_s = ' -a pmmerge.dll std.res' 
  call res''local_s
  
  szResFileName = 'LAT.RES'
  if szSimulatedCodepage <> '' then szResFileName = szSimulatedCodepage'.RES'
  call printf '...adding 850.14...'
  local_s = ' -a pmmerge.dll 'szResFileName
  call res''local_s
  
  copy' pmmerge.dll ..'SZ_DLLS_SUBDIR_NAME' >nul'
  del' pmmerge.dll >nul'
  
  call endlocal
  return

GetMajorRevision: procedure
  parse arg s
  rc = stream( s, 'c', 'open read' );
  rc = stream( s, 'c', 'seek <'27 );
  r = charin( s, ,1 );
  rc = charin( s,,1 )
  rc = charin( s, ,3 );
  rc = stream( s, 'c', 'close' );
  return r
end
GetMinorRevision: procedure
  parse arg s
  rc = stream( s, 'c', 'open read' );
  rc = stream( s, 'c', 'seek <'27 );
  rc = charin( s, ,1 );
  rc = charin( s,,1 )
  r = charin( s, ,3 );
  rc = stream( s, 'c', 'close' );
  return r
end
  
CheckSimulatedCodepage:
  parse arg s
  s = strip( translate(s) )
  if s = 'STD' then return 'STD'
  if s = SZ_CP_KOI8R then return SZ_CP_KOI8R
  if s = SZ_CP_KOI8U then return SZ_CP_KOI8U
  if s = SZ_CP_ISO   then return SZ_CP_ISO
  if s = SZ_CP_WIN   then return SZ_CP_WIN
  return ''
CheckSimulatedKeyboard:
  parse arg s
  s = strip( translate(s) )
  if s = 'STD' then return 'STD'
  if s = SZ_CP_KOI8R then return SZ_CP_KOI8R
  if s = SZ_CP_KOI8U then return SZ_CP_KOI8U
  if s = SZ_CP_ISO   then return SZ_CP_ISO
  if s = SZ_CP_WIN   then return SZ_CP_WIN
  return ''
  
CheckCountryName:
  parse arg s
  s = strip(translate(s))
  if s = ''        then return SZ_RU_TWO
  if s = SZ_RU_TWO then return SZ_RU_TWO
  if s = SZ_BY_TWO then return SZ_BY_TWO
  if s = SZ_UA_TWO then return SZ_UA_TWO
  return ''

Printf:
  parse arg s
  say SZ_WHITE''s''SZ_LGREEN
  return
Printf_err:
  parse arg s
  say SZ_LRED''s''SZ_LGREEN
  return
Scanf:
  local_s = linein(stdin)
  say SZ_GREY
  return local_s

VerbForSimulation:
  parse arg s
  if translate(strip(s))='STD' then return 'No substitution'
  return s  

VerbForPM:
  parse arg s
  if s=1 then return 'present'
  else return 'not present'
  
    
CheckBootDrive:
  parse arg s
  if strip(s) = ':' then return 0
  szBootDriveInfo = SysDriveInfo(s)
  if szBootDriveInfo = '' then return 0
  return 1
CheckBootDriveFreeSpace:
  parse arg s
  szBootDriveInfo = SysDriveInfo(s)
  local_s = word( rc, 2 )
  local_d = c2d( local_s )
  if szBootDriveInfo < I_BYTES_NEEDED then return 0
  return 1

BackupSystemFiles:
  parse arg s
  ss = s
  local_s = ss'\OS2\DLL\PMMERGE.DLL 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  local_s = ss'\OS2\DLL\PMATM.DLL 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  local_s = ss'\OS2\DLL\HELV.FON 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  local_s = ss'\OS2\DLL\TIMES.FON 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  local_s = ss'\OS2\DLL\SYSMONO.FON 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  local_s = ss'\OS2\DLL\COURIE.FON 'ss''SZ_WKW_DIR_NAME''SZ_BACKUP_SUBDIR_NAME' >nul 2>nul'
  copy local_s
  return





